package com.kmalbz

import io.ktor.application.*
import io.ktor.response.*
import io.ktor.routing.*
import java.util.*
import io.ktor.http.*

/**
 * Output Service - RDB
 * 
 * This is the output interface of the Birbnetes system.
 */
class OutputServiceRDBServer() {
    /**
     * output
     */
    fun Routing.registerOutput() {
        get("/output/filter/negative") {
            if (false) error(HttpStatusCode.NotFound)

            call.respond(listOf())
        }

        get("/output/filter/positive") {
            if (false) error(HttpStatusCode.NotFound)

            call.respond(listOf())
        }

        get("/output/after/{dateAfter}") {
            val dateAfter = call.parameters["dateAfter"]

            if (false) error(HttpStatusCode.NotFound)

            call.respond(listOf())
        }

        get("/output/before/{dateBefore}") {
            val dateBefore = call.parameters["dateBefore"]

            if (false) error(HttpStatusCode.NotFound)

            call.respond(listOf())
        }

        get("/output/{tagID}") {
            val tagID = call.parameters["tagID"]

            if (false) error(HttpStatusCode.NotFound)

            call.respond(OutputObject(
                tag = "tag",
                decison = false,
                date = Date(),
                confidence =  0.0
            ))
        }
    }
}
